#!/bin/ksh

# Warning: the commands in this script have not been fully tested
# or documented.  Use at your own risk.

# This file contains some commands for automating the indexing of
# a netscape LDAP directory.  Each section is delimited by
# "if [ 1 = 1 ];then" to enable the section and "if [ 0 = 1 ];then"
# disable the section.  Change these sections to perform the
# desired operation.  Or cut them out and paste them into individual
# scripts.

# The statements currently operate on the "principalName" and "secDN"
# attributes.  Another attribute that may improve performance is
# the "secUUID" attribute.

# Note: "cn=Directory Manager" is assumed to be the LDAP administrator account
# All occurrances must be found to change this.
ldap_pw=fsaustin	# change this to the LDAP administrator password
ldap_host=sun01		# change this to the LDAP server hostname

export LD_LIBRARY_PATH=/usr/iplanet/servers/lib

if [ `uname` = "SunOS" ];then
	AWK=nawk
else
	AWK=awk
fi

# find database instance names

instances=`/usr/iplanet/servers/shared/bin/ldapsearch -h $ldap_host \
	-D "cn=Directory Manager" -w $ldap_pw -s one \
	-b "cn=ldbm database,cn=plugins,cn=config" \
	"objectclass=nsBackendInstance" dn |
	grep -v NetscapeRoot |
	$AWK '{
		if ($1=="dn:"){
			print substr($2,4,index($2,",")-4)
		}
	}'`

if [ 1 = 1 ];then

# Create specified indexes
		
print "Doing ldapmodify to add index(es) to each of the db instances"

for instance in $instances;do

	# removing "nsIndexType" attribute in below ldif causes all index types to be turned on

	for attr in principalName secDN;do

		/usr/iplanet/servers/shared/bin/ldapmodify \
			-a -h $ldap_host -D "cn=Directory Manager" -w $ldap_pw <<EOF

dn: cn=$attr,cn=index,cn=$instance,cn=ldbm database,cn=plugins,cn=config
objectClass: top
objectClass: nsIndex
cn: $attr
nsSystemIndex: false
nsIndexType: eq

EOF
	done

done

fi

if [ 0 = 1 ];then

# Delete specified indexes

for instance in $instances;do

	for attr in principalName secDN;do

		echo "deleting cn=$attr,cn=index,cn=$instance,cn=ldbm database,cn=plugins,cn=config"
		/usr/iplanet/servers/shared/bin/ldapdelete \
			-h $ldap_host -D "cn=Directory Manager" -w $ldap_pw \
			"cn=$attr,cn=index,cn=$instance,cn=ldbm database,cn=plugins,cn=config"
	done
done

fi
if [ 0 = 1 ];then

# Query specified indexes

for instance in $instances;do

	for attr in principalName secDN;do

		/usr/iplanet/servers/shared/bin/ldapsearch \
			-h $ldap_host -D "cn=Directory Manager" -w $ldap_pw -s base \
			-b "cn=$attr,cn=index,cn=$instance,cn=ldbm database,cn=plugins,cn=config" \
			"objectclass=*"
	done
done

fi
if [ 1 = 1 ];then

# Update index files using db2index.pl


# Usage: /usr/iplanet/./servers/*/db2index.pl [-v] -D rootdn { -w password | -w - | -j filename } 
#         -n instance [-t attributeName]
#  Opts: -D rootdn          - Directory Manager
#      : -w password        - Directory Manager's password
#      : -w -               - Prompt for Directory Manager's password
#      : -j filename        - Read Directory Manager's password from file
#      : -n instance        - instance to be indexed
#      : -t attributeName   - attribute: name of the attribute to be indexed
#                             If omitted, all the indexes defined 
#                             for that instance are generated.
#      : -v                 - verbose

db2index_cmd=`find /usr/iplanet/. -name db2index.pl`

print "To complete the indexing, execute the following commands, one at a time, waiting"
print "for the system to go idle between each command."

for instance in $instances;do

	for attr in principalName secDN;do

		# sleep 5 <- hack that doesn't work
		cmd="$db2index_cmd -D \"cn=Directory Manager\" -w $ldap_pw -n $instance -t $attr"
		print $cmd
		#$db2index_cmd -D "cn=Directory Manager" -w $ldap_pw -n $instance -t $attr

		# Problem here is that db2index works asynchronously and doesn't work if
		# started again before previous invokation finishes.
		# Reading the script implies that that following query may be useful in determining
		# when the command is finished.  Need to test when there is a chance.

		# ldapsearch -D "cn=Directory Manager" -w $ldap_pw -s one \
		#	-b "cn=index,cn=tasks,cn=config" "objectclass=*" dn

	done
done

fi


