#!/bin/ksh

# Script to exclude groups from an ldif stream
#
# The script will exclude secGroup objects as well.
#
# Input: standard input device containing ldif data
# Output: standard output device with excluded group definitions

if [ `uname` = "SunOS" ];then
	AWK=nawk
else
	AWK=awk
fi

# main 

$AWK '{
	# process a line of ldif

	# If we are processing a group
	if (in_group){

		# if in a group, do not print it out
		# print $0

		# check for end of object definition
		if ($0 == ""){
			in_group = 0
		}

	} else if ($1 == "member:" || ($1 == "objectclass:" && $2 == "secGroup")) {
	# previous groupness not kown, but member attribute means in a group

		in_group = 1

		# throw away any saved lines
		sv_ln_cnt = 0

	} else if ($1 == "") {
	# not in a group, but are between ldif object definitions

		in_dn = 0

		# print out saved lines
		for (i=0;i < sv_ln_cnt;i++){
			print save_line[i]
		}
		sv_ln_cnt = 0

		print $0

	} else {
	# not in a group or between definitions, so save the lines
	# until determined

		# save the line
		save_line[sv_ln_cnt++] = $0

	}
}END{

	if (!in_group){
		# print out saved lines
		for (i=0;i < sv_ln_cnt;i++){
			print save_line[i]
		}
	}
}'

