#!/bin/ksh

# Script to exclude suffixes from an ldif stream
#
# Input: standard input device containing ldif data
# Output: standard output device with excluded suffix objects

if [ `uname` = "SunOS" ];then
	AWK=nawk
else
	AWK=awk
fi

# main 

$AWK '{
	# process a line of ldif

	# If we are processing a suffix
	if (in_suffix){

		# if in a suffix, do not print it out
		# print $0

		# check for end of suffix definition
		if ($0 == ""){
			in_suffix = 0
		}

	} else if ($1 == "dn:" && !index($0,",")) {
	# if found a suffix object

		in_suffix = 1

	} else {
	# not in a suffix

		print $0

	}
}'

