#!/bin/ksh

# Script to extract suffix objects from an ldif stream
#
# Input: standard input device containing ldif data
# Output: standard output device with extracted suffix objects

if [ `uname` = "SunOS" ];then
	AWK=nawk
else
	AWK=awk
fi

# main 

$AWK '{
	# process a line of ldif

	# If we are processing a suffix
	if (in_suffix){

		# if in a suffix, print it out
		print $0

		# check for end of object definition
		if ($0 == ""){
			in_suffix = 0
		}

	} else if ($1 == "dn:" && !index($0,",")) {
	# if found a suffix object

		in_suffix = 1
		print $0

	}
}' | grep -vi "IBM-ENTRYUUID:"


