#!/bin/ksh

if [ X$1 != X ];then
	db2diag=$1
else
	if [ `uname` = SunOS ];then
		db2diag=/export/home/ldapdb2/sqllib/db2dump/db2diag.log
	else
		db2diag=/home/ldapdb2/sqllib/db2dump/db2diag.log
	fi
fi

cat $db2diag | \
egrep 'BUILD phase|LOAD phase' | \
proc_timestamps.sh date min | \
awk '{ts=$(NF-2);
if (index($0,"Starting LOAD")){
	tab=$8$9
	tot=0
	load=0
	# print "non-load time "ts
	tabtots["total non-load time"] += ts
}else if (index($0, "Completed LOAD")){
	load+=ts
	tot+=ts
}else if (index($0, "Starting BUILD")){
	load+=ts
	tot+=ts
}else if (index($0, "Completed BUILD")){
	build=ts
	tot+=ts
	#print tab" load: "load" build: "build" "tot
	#printf("%-30s load: %-10.3f build: %-10.3f %10.3f\n",tab,load,build,tot)
	tabtots[tab] += tot
	tabloads[tab] += load
	tabbuilds[tab] += build

	tabtots["total load time"] += tot
	tabloads["total load time"] += load
	tabbuilds["total load time"] += build
}}END{
for (tab in tabtots){
	printf("%10.3f (in minutes)  %-30s load: %-10.3f build: %-10.3f\n",tabtots[tab],tab,tabloads[tab],tabbuilds[tab])
}}' | sort -rn

