#!/bin/ksh

i=1

mk_test_users_ldif.sh 1 10000 cn=testuser,o=ibm,c=us test1pass | \
	add_am_to_testusers_ldif.sh dom1 | \
	incremental_bulkload.sh with_indexes
mv inc_bulk.out inc_bulk_10k_testusers_$i.out

if [ 1 = 1 ];then

	# Add members to a group

	# start slapd
	# note that LDAP_MAXCARD=NO disables the persistent sysstat tune in LDAP 5.2.
	slapd
	LDAP_MAXCARD=NO ibmslapd -f /etc/ibmslapd.conf
	sleep 5
	ldapsearch -s base -b "" "objectclass=*" >/dev/null 2>&1
	while [ $? != 0 ];do
		sleep 1
		ldapsearch -s base -b "" "objectclass=*" >/dev/null 2>&1
	done

	mk_test_users_ldif.sh 1 10000 cn=testuser,o=ibm,c=us test1pass | \
		mk_ldap_group_ldif_stdin.sh add cn=everyonegroup,o=ibm,c=us | \
		incremental_group.sh
	mv inc_group.out inc_group_testusers_$i.out

	# stop slapd
	kill -9 `ps -ef -o pid,comm | grep slapd | awk '{print $1}'`
	sleep 5

else

	# create the group

	mk_test_users_ldif.sh 1 10000 cn=testuser,o=ibm,c=us test1pass | \
		mk_ldap_group_ldif_stdin.sh create cn=everyonegroup,o=ibm,c=us | \
		add_am_to_groups_ldif.sh dom1 | incremental_bulkload.sh with_indexes
	mv inc_bulk.out inc_bulk_10k_group_testusers_$i.out

fi

su - ldapdb2 -c "$PWD/fixacls_propagate_parents_once.sh" | tee -a fixacls_prop_par_once_10k_testusers_$i.out


